#ifndef __RENDERING_INIT_H__
#define __RENDERING_INIT_H__

#include "struct.h"
#include "../helpers.h"
// s = the state struct


// init the glfw window
// requires: none
// produces: s.window, s.extensions, s.devextensions
void rendering_initGLFW(struct rendering_state *s);

// requires: s.window
// produces: s.instance, s.surface, s.extensions(may be null), s.layers(may be null)
void rendering_vkinstance(struct rendering_state *s);

// requires: everything untill s.physdevice
// produces: s.queues
void rendering_vkgetfamilies(struct rendering_state *s);

// requires: s.queues, s.physdevice, s.surface, s.deviceextensions
// produces: s.device
void rendering_vkdevice(struct rendering_state *s);

// requires: vkdevice, and all of it's requirements
// produces: s.swapchain
void rendering_vkswapchain(struct rendering_state *s);

VkShaderModule rendering_createShaderModule(sizedData shadercode, VkDevice device);

// requires: s.pipeline.renderpass
void rendering_createframebuffers(struct rendering_state *s);

void rendering_cleanupSwapchain(struct rendering_state *s);

void rendering_createCommandPools(struct rendering_state *s);

void rendering_createSyncObjects(struct rendering_state *s);

#endif