#include "data.h"
#include "../vulkan/swapchain.h"
#include <unicode/urename.h>
#include "setup.h"


const VkSamplerCreateInfo pipelineTextdefaultSamplerInfo = {
    VK_STRUCTURE_TYPE_SAMPLER_CREATE_INFO,
    NULL,
    0,
    VK_FILTER_LINEAR,
    VK_FILTER_LINEAR,
    VK_SAMPLER_MIPMAP_MODE_NEAREST,
    VK_SAMPLER_ADDRESS_MODE_CLAMP_TO_EDGE,
    VK_SAMPLER_ADDRESS_MODE_CLAMP_TO_EDGE,
    VK_SAMPLER_ADDRESS_MODE_CLAMP_TO_EDGE,
    0.f,
    VK_FALSE,
    0.f,
    VK_FALSE,
    VK_COMPARE_OP_ALWAYS,
    0.f,
    0.f,
    VK_BORDER_COLOR_INT_TRANSPARENT_BLACK,
    VK_FALSE
};

const VkSamplerCreateInfo *pipelineTextgetDefaultSamplerCi(){
    return &pipelineTextdefaultSamplerInfo;
}

void setupFontTextureForRender(struct rendering_state *s, struct Font *f, VkSamplerCreateInfo *samplerOverride){
    svlk_createVkImageView(s->device, f->buffer->image, VK_IMAGE_VIEW_TYPE_2D, f->buffer->fmt, &f->buffer->view);
    vkCreateSampler(s->device, samplerOverride ? samplerOverride : pipelineTextgetDefaultSamplerCi(), NULL, &f->buffer->sampler);
    
    createFontTextureDesctiptorSet(s, f);
    updateFontTextureDescriptorSet(s, f);
}
