#ifndef __PIPELINE_TEXT_DATA_H__
#define __PIPELINE_TEXT_DATA_H__
#include "../vulkan/gpumem.h"
#include <cglm/types.h>
#include <vulkan/vulkan_core.h>

#ifndef STB_TRUETYPE_IMPLEMENTATION
#include <stb/stb_truetype.h>
#endif

#include <stdint.h>
// this is an element in a buffer
struct PipelineTextUniformBufferObject{
    vec2 p[4]; // TL, TR, BL, BR
    
    vec2 bp0; // position of the top left in the atlas
    vec2 bp1; // position of bottom right in the atlas 
};

struct Font{
    int w;
    int h;
    stbtt_packedchar *chardata;
    struct gpuimage *buffer;
    VkDescriptorSet descriptor;
};

// a simple text element, defines a string to be printed at a specific position
struct textElement {
    char *text;
    uint32_t length; // in unicode codepoints
    uint32_t length_bytes; // length in bytes
    uint16_t flags;
    mat4 matrix;
    struct Font *font;
    struct PipelineTextUniformBufferObject *compiled;
};

void setupFontTextureForRender(struct rendering_state *s, struct Font *f, VkSamplerCreateInfo *samplerOverride);

#endif