#include "commandpools.h"
#include <vulkan/vulkan_core.h>

VkResult svlk_createCommandPool(VkDevice device, int familyindex, int flags, VkCommandPool *commandpool){
    VkCommandPoolCreateInfo createinfo = {
        VK_STRUCTURE_TYPE_COMMAND_POOL_CREATE_INFO,
        NULL,
        flags,
        familyindex
    };
    return vkCreateCommandPool(device, &createinfo, NULL, commandpool);
}

VkResult svlk_allocateCommandBuffer(VkDevice device, VkCommandPool cmdpool, int level, int count, VkCommandBuffer *cmdbuffers){
    VkCommandBufferAllocateInfo allocinfo = {
        VK_STRUCTURE_TYPE_COMMAND_BUFFER_ALLOCATE_INFO,
        NULL,
        cmdpool,
        level,
        count
    };
    return vkAllocateCommandBuffers(device, &allocinfo, cmdbuffers);
}

VkResult svlk_recordCommandBuffer(VkCommandBuffer cmdbuf, VkImage image, uint32_t flags){
    VkCommandBufferBeginInfo begininfo = {
        VK_STRUCTURE_TYPE_COMMAND_BUFFER_BEGIN_INFO,
        NULL,
        flags,
        NULL
    };

    return vkBeginCommandBuffer(cmdbuf, &begininfo);
}

VkResult svlk_createSemaphore(VkDevice device, VkSemaphore *semaphore){
    VkSemaphoreCreateInfo semaphoreCreateinfo = {VK_STRUCTURE_TYPE_SEMAPHORE_CREATE_INFO, NULL, 0};
    return vkCreateSemaphore(device, &semaphoreCreateinfo, NULL, semaphore);
}

VkResult svlk_createFence(VkDevice device, VkFence *fence, VkFenceCreateFlags flags){
    VkFenceCreateInfo semaphoreCreateinfo = {VK_STRUCTURE_TYPE_FENCE_CREATE_INFO, NULL, flags};
    return vkCreateFence(device, &semaphoreCreateinfo, NULL, fence);
}