#ifndef __SVULC_H__
#define __SVULC_H__

#include <vulkan/vulkan_core.h>

VkResult svlk_createIinstance(const char **layers, int layersNum, const char **extensions, int extensionsNum, VkInstance *instance);

VkResult svlk_getPhysDeviceList(VkInstance instance, unsigned int *num, VkPhysicalDevice **devicesPointer);

int svlk_getQueueFamilyIndex(VkPhysicalDevice physDevice, VkQueueFlags queueFlag, int *error);

int svlk_getPresentQueueFamilyIndex(VkPhysicalDevice physDevice, VkSurfaceKHR KHRsurface, int *error);

int svlk_deviceCompatable(VkPhysicalDevice physDevice, VkSurfaceKHR surface, unsigned int queueFamilies, const char **deviceExtensions, int deviceExtensionsNum);

VkDeviceQueueCreateInfo svlk_createQueueInfo(int queueIndex, int count, float *priority);

VkResult svlk_createLogicalDevice(
    VkPhysicalDevice physDevice,
    VkSurfaceKHR surface,
    VkDeviceQueueCreateInfo *queueFamilies,
    unsigned int queueFamiliesNum,
    VkPhysicalDeviceFeatures deviceFeatures,
    const char **deviceExtensions,
    int deviceExtensionsNum,
    void *pNext,
    VkDevice *device);

#endif